文章标题 HDU 3853:LOOPS (概率DP)

3 篇文章 1 订阅

Loops

Description

Akemi Homura is a Mahou Shoujo (Puella Magi/Magical Girl).

Homura wants to help her friend Madoka save the world. But because of the plot of the Boss Incubator, she is trapped in a labyrinth called LOOPS.

The planform of the LOOPS is a rectangle of R*C grids. There is a portal in each grid except the exit grid. It costs Homura 2 magic power to use a portal once. The portal in a grid G(r, c) will send Homura to the grid below G (grid(r+1, c)), the grid on the right of G (grid(r, c+1)), or even G itself at respective probability (How evil the Boss Incubator is)!
At the beginning Homura is in the top left corner of the LOOPS ((1, 1)), and the exit of the labyrinth is in the bottom right corner ((R, C)). Given the probability of transmissions of each portal, your task is help poor Homura calculate the EXPECT magic power she need to escape from the LOOPS.

Input

The first line contains two integers R and C (2 <= R, C <= 1000).

The following R lines, each contains C*3 real numbers, at 2 decimal places. Every three numbers make a group. The first, second and third number of the cth group of line r represent the probability of transportation to grid (r, c), grid (r, c+1), grid (r+1, c) of the portal in grid (r, c) respectively. Two groups of numbers are separated by 4 spaces.

It is ensured that the sum of three numbers in each group is 1, and the second numbers of the rightmost groups are 0 (as there are no grids on the right of them) while the third numbers of the downmost groups are 0 (as there are no grids below them).

You may ignore the last three numbers of the input data. They are printed just for looking neat.

The answer is ensured no greater than 1000000.

Terminal at EOF

Output

A real number at 3 decimal places (round to), representing the expect magic power Homura need to escape from the LOOPS.

Sample Input

2 2
0.00 0.50 0.50 0.50 0.00 0.50
0.50 0.50 0.00 1.00 0.00 0.00

Sample Output

6.000

题意:有一个R*C的网格,每走一次消耗2点体力,要从(1,1)走到(R,C),每个格子有三种可能,当前为(i,j)可能想下走变成(i+1,j),可能向右走变成(i,j+1),也可能在当前为(i,j),三种可能的情况的概率之和为1。现在要求走到出口需要体力值的期望。
分析:这是一道概率动态规划的问题,求的是期望,用一个二维数组 f[i][j] 表示到达目标的体力的期望。显然 f[R][C]=0,可以得到递推关系 f[i][j] =f[i][j]*p1+f[i+1][j]*p2+f[i][j+1]*p3,但还有一个特殊情况,就是当留在原地的概率为1时。

代码:

#include<iostream>
#include<string>
#include<cstdio>
#include<cstring>
#include<vector>
#include<math.h>
#include<queue> 
#include<algorithm>
using namespace std;
int r,c;
struct node {
    double down,right,now;
}; 
node a[1005][1005];
double dp[1005][1005];
int main ()
{
    while (scanf ("%d%d",&r,&c)!=EOF){
        for (int i=0;i<1005;i++){
            memset (a[i],0,sizeof (a[i]));
        }
        for (int i=1;i<=r;i++){
            for (int j=1;j<=c;j++){
                scanf ("%lf%lf%lf",&a[i][j].now,&a[i][j].right,&a[i][j].down);
            }
        }
        memset (dp,0,sizeof (dp));
        dp[r][c]=a[r][c].right * 2;
        //dp[r][c]=0;
        for (int i=r;i>=1;i--){
            for (int j=c;j>=1;j--){
                if (i==r&&j==c)continue;
                if (1-a[i][j].now<1e-8)continue;//特殊情况,有可能now的概率的1,不能用递推关系求,此时为0; 
                dp[i][j]=(dp[i+1][j]*a[i][j].down+dp[i][j+1]*a[i][j].right+2)/(1-a[i][j].now);
            }
        }
        printf ("%.3f\n",dp[1][1]); 
    }
    return 0;
}

刚开始没想到留在原地的概率可能为1,所以过了样例最后还是WA,还有其实可以用三个数组存储三种可能情况的概率。

  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值